Bug 729020 - Debuginfo package issues in cyrus-imapd
Debuginfo package issues in cyrus-imapd
Status: ASSIGNED
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: cyrus-imapd (Show other bugs)
6.3
Unspecified Unspecified
low Severity low
: rc
: ---
Assigned To: Pavel Šimerda (pavlix)
qe-baseos-daemons
: EasyFix
Depends On: 251333
Blocks: 727919 1356044
  Show dependency treegraph
 
Reported: 2011-08-08 11:19 EDT by Karel Klíč
Modified: 2016-07-21 08:37 EDT (History)
3 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)

  None (edit)
Description Karel Klíč 2011-08-08 11:19:46 EDT
Several problems related to debuginfo were found in the cyrus-imapd-2.3.16-6.el6_1.2 package. These issues might affect crash analysis done by Automatic Bug Reporting Tool and its retrace server, and also prevent proper debugging of crashes via GDB.

Debuginfo missing for binaries
------------------------------
Debuginfo files for some binaries are not present in the debuginfo package. This might be caused by:
 - binary being compiled without debugging information
 - debugging information being removed from the binary by a build script
 - rpmbuild failing to extract debugging information from a binary in a buildroot because of permissions (eg. suid binaries, binaries without executable flag set)

List of binaries without corresponding debuginfo file:
- affected binary: /usr/bin/smtptest
  affected package: cyrus-imapd-utils-2.3.16-6.el6_1.2.i686
  binary doesn't contain debug sections (it was probably stripped)
  affected binary file mode: 100755
- affected binary: /usr/bin/sivtest
  affected package: cyrus-imapd-utils-2.3.16-6.el6_1.2.i686
  binary doesn't contain debug sections (it was probably stripped)
  affected binary file mode: 100644
- affected binary: /usr/bin/pop3test
  affected package: cyrus-imapd-utils-2.3.16-6.el6_1.2.i686
  binary doesn't contain debug sections (it was probably stripped)
  affected binary file mode: 100644
- affected binary: /usr/bin/nntptest
  affected package: cyrus-imapd-utils-2.3.16-6.el6_1.2.i686
  binary doesn't contain debug sections (it was probably stripped)
  affected binary file mode: 100644
- affected binary: /usr/bin/lmtptest
  affected package: cyrus-imapd-utils-2.3.16-6.el6_1.2.i686
  binary doesn't contain debug sections (it was probably stripped)
  affected binary file mode: 100644
- affected binary: /usr/bin/mupdatetest
  affected package: cyrus-imapd-utils-2.3.16-6.el6_1.2.i686
  binary doesn't contain debug sections (it was probably stripped)
  affected binary file mode: 100644
- affected binary: /usr/bin/synctest
  affected package: cyrus-imapd-utils-2.3.16-6.el6_1.2.i686
  binary doesn't contain debug sections (it was probably stripped)
  affected binary file mode: 100644

This issue can be investigated by using eu-readelf tool from the elfutils package. Use `eu-readelf --notes /path/to/binary` to get build ID of a binary. Then check that the debuginfo package does not contain /usr/lib/debug/.build-id/<aa>/<bbbbbbbb>, where <aa> are the first two chars of the build ID, and <bbbbbbbb> is the rest of it. It should be a symlink pointing back to the binary.

Source file missing in debuginfo package
----------------------------------------
Multiple source files that were used by the compiler to generate a binary are missing from the debuginfo package. This is usually caused by the build script creating temporary source files during the build and deleting them after usage, or by moving source files between directories. Missing source files in debuginfo packages make debugging of crashes more difficult.

debuginfo package: cyrus-imapd-debuginfo-2.3.16-6.el6_1.2.i686
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/cyrus-master.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/master/lock_fcntl.c
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/sync_client.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/ctl_deliver.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/deliver.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/cyr_df.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/fud.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/idled.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/cyr_expire.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/sync_reset.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/imapd.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/cyr_synclog.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/compile_sieve.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/make_md5.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/pop3d.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/ptdump.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/quota.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/ctl_mboxlist.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/smmapd.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/unexpunge.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/mupdate.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/chk_cyrus.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/cyrfetchnews.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/reconstruct.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/ptexpire.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/make_sha1.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/notifyd.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/notifyd/mutex_fake.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/tls_prune.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/mbexamine.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/sieved.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/cvt_cyrusdb.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/ctl_cyrusdb.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/ptloader.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/squatter.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/mbpath.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/sievec.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/nntpd.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/lmtpd.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/ipurge.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/sync_server.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/cyrdump.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/cyr_dbtool.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/arbitron.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h
  debuginfo file: /usr/lib/debug/usr/lib/cyrus-imapd/timsieved.debug
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.c
    missing source: /usr/src/debug/cyrus-imapd-2.3.16/sieve/y.tab.h

Please consider changing the package build script (if that is the cause of this issue) to keep the source files on their compilation place, so rpmbuild can find them when generating debuginfo package.

(This bug was detected and filed by a script.)
Comment 2 RHEL Product and Program Management 2011-08-08 11:42:03 EDT
This request was evaluated by Red Hat Product Management for
inclusion in the current release of Red Hat Enterprise Linux.
Because the affected component is not scheduled to be updated
in the current release, Red Hat is unfortunately unable to
address this request at this time. Red Hat invites you to
ask your support representative to propose this request, if
appropriate and relevant, in the next release of Red Hat
Enterprise Linux. If you would like it considered as an
exception in the current release, please ask your support
representative.
Comment 3 Michal Sekletar 2011-10-14 08:22:00 EDT
Created attachment 528196 [details]
Replace hardlinks with symlinks

This issue is caused by bug in rpm. Affected binaries without corresponding
.debug files are all hard-links to the same binary and find-debuginfo.sh is
unable to generate .debug files properly because of bug #251333. See attached
patch addressing the issue. I think we could use this workaround until #251333 is resolved.
Comment 5 Pavel Šimerda (pavlix) 2015-12-01 14:24:03 EST
(In reply to Michal Sekletar from comment #3)
> Created attachment 528196 [details]
> Replace hardlinks with symlinks
> 
> This issue is caused by bug in rpm. Affected binaries without corresponding
> .debug files are all hard-links to the same binary and find-debuginfo.sh is
> unable to generate .debug files properly because of bug #251333. See attached
> patch addressing the issue. I think we could use this workaround until
> #251333 is resolved.

I would like to revisit this ticket. The respective bug in rpm is fixed according to bug #251333. How does it affect cyrus-imapd? What is needed to close this bug? Just a rebuild?
Comment 6 Pavel Šimerda (pavlix) 2015-12-01 14:26:37 EST
(In reply to Pavel Šimerda (pavlix) from comment #5)
> (In reply to Michal Sekletar from comment #3)
> > Created attachment 528196 [details]
> > Replace hardlinks with symlinks
> > 
> > This issue is caused by bug in rpm. Affected binaries without corresponding
> > .debug files are all hard-links to the same binary and find-debuginfo.sh is
> > unable to generate .debug files properly because of bug #251333. See attached
> > patch addressing the issue. I think we could use this workaround until
> > #251333 is resolved.
> 
> I would like to revisit this ticket. The respective bug in rpm is fixed
> according to bug #251333. How does it affect cyrus-imapd? What is needed to
> close this bug? Just a rebuild?

I now see that the bug was closed but not fixed (WONTFIX). What is your suggestion in this situation?
Comment 7 Michal Sekletar 2015-12-03 07:31:27 EST
(In reply to Pavel Šimerda (pavlix) from comment #6)
> 
> I now see that the bug was closed but not fixed (WONTFIX). What is your
> suggestion in this situation?

Well, in case that problem described in #251333 still persists then comment #3 still applies...I guess...Since comment #3 was meant as a suggestion, you should look at what imtest does differently when invoked via hardlink, most likely jumps to some "main" function for given argv[0]. If that is the case then replacing hardlink with symlink should be harmless and should fix debug-info issue.

Note You need to log in before you can comment on or make changes to this bug.